--!parent
--!encoding=utf-8

property ancestor

property pCbObject
property pCbHandler
property pSingleShotFlag
property pArgs

----------------------------------------
-- @constructor
----------------------------------------
on new (me, tName, tPeriod, tCbHandler, tCbObject, tSingleShotFlag, tArgs)
  if voidP(tCbObject) then tCbObject = _movie
  if voidP(tSingleShotFlag) then tSingleShotFlag = false
  
  me.pCbObject = tCbObject
  me.pCbHandler = tCbHandler
  me.pSingleShotFlag = tSingleShotFlag
  me.pArgs = tArgs
  
  --me.ancestor = timeout().new(tName, tPeriod, #_done, me)
  
  -- force FIFO instead of STACK behavior
  t = timeout().new(tName, tPeriod, #_done, me)
  cnt = _movie.timeoutList.count
  if cnt>1 then
  	_movie.timeoutList.deleteAt(cnt)
  	_movie.timeoutList.addAt(1, t)  		
  end if
  me.ancestor = t
  	
  return me
end

----------------------------------------
-- @access private
----------------------------------------
on _done (me)
	-- $.important: forget BEFORE call, otherwise ignored in case of errors in call!
  if me.pSingleShotFlag then me.forget()
  	
  args = ""
  cnt = me.pArgs.count
  repeat with i = 1 to cnt
    put ",me.pArgs["&i&"]" after args
  end repeat
  cmd = "call(me.pCbHandler,me.pCbObject"&args&")"
  do(cmd)
end
